freeslot("MT_SPRINGPOWAH", "MT_SPRINGBOX", "MT_SPRINGICON", "S_MONITOR_SPRING", "S_SPRINGICON1", "S_SPRINGICON2", "SPR_SPTV", "SPR_ICSP")

mobjinfo[MT_SPRINGPOWAH] = {
	doomednum = -1,
	spawnstate = S_REDSPRING,
	spawnhealth = 9999999,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	activesound = sfx_None,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

mobjinfo[MT_SPRINGBOX] = {
	doomednum = 2418,
	spawnstate = S_MONITOR_SPRING,
	spawnhealth = 1,
	radius = 16*FRACUNIT,
	height = 48*FRACUNIT,
	mass = 100,
	damage = 0,
	activesound = sfx_None,
	damage = MT_SPRINGICON,
	deathstate = S_BOX_POP1,
	deathsound = sfx_pop,
	flags = MF_MONITOR|MF_SOLID|MF_SHOOTABLE
}
	
mobjinfo[MT_SPRINGICON] = {
      doomednum = -1,
      spawnstate = S_SPRINGICON1,
      spawnhealth = 1,
      speed = 2*FRACUNIT,
      radius = 8*FRACUNIT,
      height = 14*FRACUNIT,
      mass = 100,
      damage = 62*FRACUNIT,
      flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON
}

function A_GivePogoSpring(actor, var1, var2)
         if actor.target.player
		    P_SpawnMobj(actor.target.x, actor.target.y, actor.target.z, MT_SPRINGPOWAH)
			actor.target.spring = true
	     end
end

states[S_MONITOR_SPRING] = {SPR_SPTV, A, 10, nil, 0, 0, S_BOX_FLICKER}

states[S_SPRINGICON1] = {SPR_ICSP, A, 26, nil, 0, 0, S_SPRINGICON2}

states[S_SPRINGICON2] = {SPR_ICSP, A, 12, A_GivePogoSpring, 0, 0, S_NULL}

addHook("PlayerThink", function(player)
     if player.mo.spring == true
	    player.mo.state = S_PLAY_STND
		player.pflags = $ &~ PF_SPINNING
	    if P_IsObjectOnGround(player.mo) then
		   P_SetObjectMomZ(player.mo, 20*FRACUNIT, false)
		   S_StartSound(player.mo, sfx_spring)
		end
	    if player.cmd.buttons & BT_JUMP and player.jumpisbeingpressed == false
		   P_DoJump(player)
		   player.mo.spring = false
		end
		if player.cmd.buttons & BT_JUMP
		   player.jumpisbeingpressed = true
		else
		   player.jumpisbeingpressed = false
		end
		if player.powers[pw_flashing] then
		   player.mo.state = S_PLAY_PAIN
		   player.mo.spring = false
		end
		if player.powers[pw_carry] then
		   player.mo.spring = false
		end
		if player.deadtimer then
		   player.mo.state = S_PLAY_DEAD
		   player.mo.spring = false
		end
     end
end)

addHook("TouchSpecial", function(thing, tmthing)
          if not tmthing.player then return end
		  if not thing.playerhasbeenset
		  thing.target = tmthing
		  thing.playerhasbeenset = true
		  end
		  return true
end, MT_SPRINGPOWAH)

addHook("MobjThinker", function(mobj)
        if mobj.target != nil and mobj.target.type == MT_PLAYER
		  if mobj.target.spring == true
           P_MoveOrigin(mobj, mobj.target.x, mobj.target.y, mobj.target.z-16*FRACUNIT)
		   if P_IsObjectOnGround(mobj.target)
		      mobj.state = S_REDSPRING2
		   end
		  else
		    mobj.flags = $ &~ MF_NOGRAVITY
		    if P_IsObjectOnGround(mobj)
		       P_RemoveMobj(mobj)
		    end
		  end
		end
end, MT_SPRINGPOWAH)